<?php
/**
 * Konfiguration der berofos Parameter
 * @author Gürsel Kücük <gk@beronet.com>
 */
class Berofos {

	/**
	 * Attributs
	 */
	private		$m_attr;

	private		$post_attr 	= array(),
			$post_checked 	= 0;
	
	private		$isRequestRejected = 0,
			$reasonRejected = array();

        function __construct($m, $get = array(), $post = array(), $session = array()) {
		// set main GET variable
		$this->m_attr = $m;

		// check POST variable
		if (isset($post['action'])) {
			unset($post['m']);

			$list_post = array(	'action' 	=> 'select'	, 'ip_address' 		=> 'hostname'	, 'mac_address' => 'mac', 
						'interval' 	=> 'int>=0'	, 'use_boot_bnfos_wdog' => 'bool'	);

			$list_options_select = array( 'action' => array('Activate', 'Aktivieren', 'Deactivate', 'Deaktivieren', 'Save', 'Speichern')); // must rework the class to generalize ite

			$this->post_checked = 1;
			$this->post_attr = Helper::sanitizePost($post, $list_post, $this->post_checked, $this->reasonRejected, $list_options_select);

			$this->isRequestRejected = !$this->post_checked;
		}
	}

	public function display() {
		$ba = new beroAri();
		include '/usr/fallback/beroConf.php';
		$bc = new beroConf('root');	
		$name = "BEROFOS_TITLE_DIS";
		include('./includes/header.php');

		// TODO: rework the save functionnality into a function with: if ($this->post_checked) { $this->save($this->post_attr); }
		// 
		//			function save($arg) {
		//				switch ($arg['action']) {
		//					case 1:
		//						do stuff
		//					case 2:
		//						do stuff
		//				}
		//			}
		//
		// Activate
		if ($this->post_checked && $this->post_attr['action'] == BUTTON_ACTIVATE) {
			// kill all
			system("killall -9 bnfos");
			// test post variable and execute bnfos
			system("bnfos --kick -b -c -h " . $this->post_attr['ip_address'] . " -m " . $this->post_attr['mac_address'] . " -w" . $this->post_attr['interval']);
		}
		// Deactivate
		else if ($this->post_checked && $this->post_attr['action'] == BUTTON_DEACTIVATE) {
			//kill any running bnfos
			system("killall -9 bnfos");
		}
		// Save
		else if ($this->post_checked && $this->post_attr['action'] == BUTTON_SAVE) {
			$ba->set("ip_berofos", sqlite_escape_string($this->post_attr['ip_address']));
			$ba->set("mac_berofos", sqlite_escape_string($this->post_attr['mac_address']));
			$ba->set("interval_berofos", sqlite_escape_string($this->post_attr['interval']));
			if (isset($this->post_attr['use_boot_bnfos_wdog'])) {
				$bc->set("root", "use_boot_bnfoswdog", '1');
			} else {
				$bc->set("root", "use_boot_bnfoswdog", '0');
			}
			$retps = exec("ps x|grep bnfos|grep -v 'grep\|sed'|wc -l");
			if ($retps == 1) {
				// killall
				system("killall -9 bnfos");
				// check input post and execute bnfos
				system("bnfos --kick -b -c -h " . $this->post_attr['ip_address'] . " -m " . $this->post_attr['mac_addr'] . " -w" . $this->post_attr['interval']);
			}
			$berofos_table .= Helper::activate(1, true, $this->m_attr, ACTIVATE);
		} else if ($this->isRequestRejected) {
			$ret .= Helper::displayErrorMessage($this->reasonRejected['request'], $this->reasonRejected['checkor'], $this->reasonRejected['key']);
		}

		$m = $this->m_attr;
		$berofos_table .= $this->dynamic_table();
		ob_start();
		?>
		<form name='berofos' id='berofos_form' action='' class="form-horizontal" method='POST'>
			<input type=hidden name=m value="<? echo $m; ?>">
			<br>
			<? echo $berofos_table; ?>
			<br>
		</form>
		<script>
		    $("#berofos_form").validate({
		        rules: {
		            ip_address: {
		                required: true,
				checkHostname: true,
		            },
		            interval: {
		                required: true,
		                digits: true,
		            },
		            mac_address: {
		                required: true,
		                checkMac: true,
		            },
		        }
		    });
		</script>
		<?php
		$ret .= ob_get_clean();
		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}

	public function start_bnfos() {
		
	}

	public function stop_bnfos() {
		
	}

	public function dynamic_table() {
		$ba = new beroAri();
		$bc = new beroConf('root');
		require_once("./includes/lang.php");

		$retps = exec("ps x|grep bnfos|grep -v 'grep\|sed'|wc -l");
		$bnfosstate = $retps;

		ob_start();
		?>

		<p class="text-center lead" ><? echo BEROFOS_TABLE_HEADER_DIS; ?></p>
		<div class='form-group' data-toggle='tooltip' title='<? echo BNFOSIP; ?>'>
			<label for='ip_address' class='col-sm-5 control-label'><? echo BEROFOS_IP_ADDRESS_DIS; ?></label>
			<div class='col-sm-4'>
				<input name="ip_address" class="form-control input-sm" type="text" size="15" value="<? echo $ba->get('ip_berofos'); ?>">
			</div>
		</div>
		<div class='form-group' data-toggle='tooltip' title='<? echo BNFOSMAC; ?>'>
			<label for='mac_address' class='col-sm-5 control-label'><? echo BEROFOS_MAC_ADDRESS_DIS; ?></label>
			<div class='col-sm-4'>
				<input name="mac_address" class="form-control input-sm" type="text" size="15" value="<? echo $ba->get('mac_berofos'); ?>">
			</div>
		</div>
		<div class='form-group' data-toggle='tooltip' title='<? echo BNFOSINTERVALL; ?>'>
			<label for='interval' class='col-sm-5 control-label'><? echo BEROFOS_INTERVAL_DIS; ?></label>
			<div class='col-sm-4'>
				<input name="interval" class="form-control input-sm" type="text" size="15" value="<? echo $ba->get('interval_berofos'); ?>">
			</div>
		</div>
		<div class='form-group' data-toggle='tooltip' title='<? echo BNFOSUSEBOOTWDOG; ?>'>
			<label for='use_boot_bnfos_wdog' class='col-sm-5 control-label'><? echo BEROFOS_HEARTBEAT_ON_BOOT_DIS; ?></label>
			<div class='col-sm-4'>
				<input type='checkbox' name='use_boot_bnfos_wdog' id='use_boot_bnfos_wdog' value='1' 
				<?
				echo ($bc->get('root', 'use_boot_bnfoswdog') == "1" || $bc->get('root', 'use_boot_bnfoswdog') == "yes") ?
					"checked" : "";
				?>>
			</div>
		</div>
		<div class="text-center" data-toggle='tooltip' title='<? echo BNFOSSAVE; ?>'>
			<input type='submit' class='btn btn-default' name='action' Value='<? echo BUTTON_SAVE; ?>'>
		</div>
		<br>
		<p class="text-center lead" ><? echo BEROFOS_HEARTBEAT_STATE_DIS; ?></p>
		<div class='form-group' data-toggle='tooltip' title='<? echo BNFOSSTATE; ?>'>
			<div class='col-sm-6 control-label img-responsive'>
				<img src='<? echo ($bnfosstate == 1) ? "./includes/images/punkt_gruen.gif" : "./includes/images/punkt_rot.gif"; ?>'>
			</div>
			<div class='col-sm-6'>
				<input type='submit' name='action' class='btn btn-default' value='<? echo ($bnfosstate == 1) ? BUTTON_DEACTIVATE : BUTTON_ACTIVATE; ?>'>
			</div>
		</div>
		<div class='text-center'><i><? echo REQUIRED_FIELDS; ?></i></div>
		<?
		return ob_get_clean();
	}

}
?>
